package com.eactive.eai.batch.job.jobItem.zeniel;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.HashMap;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_ZENEL_0300 extends DefaultTelegram implements TelegramService
{

    private int INFORMALFIELD_INDEX = 11;
    /**
     * 생성자
     */
    public RECV_ZENEL_0300() {
        //결번확인통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String _missing_count = new String ((byte[]) al_Field.get(10));
            String missing_field  = new String ((byte[]) al_Field.get(11));
            int recv_migging_count = Integer.parseInt(_missing_count);
            if (recv_migging_count == 0 ) {
                if (!checkFileEOF()) {
                    return false;
                }
                String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
                JobProcessData job = JobProcessData.getInstance();
                HashMap<String, Object> hm = job.getBatchStageData(uuid);
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    // Vector 초기화
            } else if (recv_migging_count > 0) {
                this.setConditionTxt(TelegramKeys.LOSS);
            }
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(recv_migging_count);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(missing_field);
        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {
        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            try {
                String byte_size = new String ((byte[]) al_Field.get(0));
                int tot_byte_size = Integer.parseInt(byte_size);
                int read_byte_size = 0;
                for (int i=1; i < idx; i++){
                    read_byte_size += al_Field.get(i).length;
                }
                return tot_byte_size - read_byte_size;
            } catch(Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI005";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error( e.getMessage(), e);
                return -1;
            }
        } else {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
    }

    public boolean doInformalField(int idx, byte[] data, int length)
    {
        try {
            if (idx == INFORMALFIELD_INDEX) {
                ByteArrayInputStream bin = new ByteArrayInputStream (data, 0, length);
                byte[] xxField = new byte[length];
                bin.read(xxField, 0, length);
                al_Field.set(idx, xxField);
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            }
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI004";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<8; i++) { //제니엘 CMS전문의 헤더는 응답코드까지 임(TRANSACTION CODE 삭제)
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=8; i< al_Field.size()-1; i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            return true;
        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean checkFileEOF() {
        try {
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }
            String fileName = fileDir + fileNm;

            File realFile = new File(fileName);
            if (!realFile.exists()) // 파일이 없으면 리턴 False
            {
                logger.debug("{} the File["+ realFile.getName() + "] does not exist!!!", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = realFile.getName();
                String errCode = "BECEAIFJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }

            if (    batchDoc.getBatchMsg().getHeader().getFileSize()
                 <= batchDoc.getBatchMsg().getBody().getCurFileSize()) {
                checkMoreFileinDB();
            }

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI023";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;

    }

    private void checkMoreFileinDB(){
        this.setConditionTxt(TelegramKeys.NOFILE);
        return;
//        String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
//        String institutionCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
//        SchedulerMessageVO info;
//        try{
//            info = SchedulerMessageManager.getInstance().getExecutableJobFromQueue(processCode, institutionCode );
//            if ( info == null ) {
//                this.setConditionTxt(TelegramKeys.NOFILE);
//                return;
//            }
//            LogUtil.setLogFileEnd(batchDoc);
//            String strUUID = batchDoc.getBatchMsg().getHeader().getUUID();
//            String strSubUUID = batchDoc.getBatchMsg().getBody().getSubUUID();
//
//            //해당 작업을 Job_Queue 테이블에서 Job_Processing 테이블로 이동
//            SchedulerMessageManager.getInstance().moveJobQueueToHandleWithNewID(info, strUUID, strSubUUID);
//
//            //BatchMsgDoc 값 설정
//            batchDoc.getBatchMsg().getHeader().setScheduleCode(info.getScheduleCode());
//            batchDoc.getBatchMsg().getHeader().setScheduleSTime(info.getStartTime());
//            batchDoc.getBatchMsg().getHeader().setScheduleETime(info.getEndTime());
//            batchDoc.getBatchMsg().getHeader().setFilePath(info.getFilePath());
//            batchDoc.getBatchMsg().getHeader().setFileName(info.getFileName());
//            batchDoc.getBatchMsg().getHeader().setRenamedFileName(info.getRenamedFileName());
//            batchDoc.getBatchMsg().getHeader().setJobCode(info.getJobCode());
//            // 0600 전문을 보내어 현재 파일을 마무리 하여야 하므로 여기서 BizCode를 세팅하면 안된다.
//            //batchDoc.getEAIBatchMessage().getHeader().setBizCode(info.getBizCode());
//            batchDoc.getBatchMsg().getHeader().setHdrInfoName(info.getHdrInfoName());
//            batchDoc.getBatchMsg().getHeader().setFlowCode(info.getFlowRuleCode());
//            batchDoc.getBatchMsg().getHeader().setRuleCode(info.getFlowRuleCode());
//            batchDoc.getBatchMsg().getHeader().setBlockSize(info.getBlockSize());
//            batchDoc.getBatchMsg().getHeader().setSequenceSize(info.getSequenceSize());
//            batchDoc.getBatchMsg().getHeader().setPacketSize(info.getPacketSize());
//            batchDoc.getBatchMsg().getHeader().setUserID(info.getRemoteUserID());
//            batchDoc.getBatchMsg().getHeader().setUserPassword(info.getRemoteUserPW());
//            batchDoc.getBatchMsg().getHeader().setFileSize(0);
//            batchDoc.getBatchMsg().getBody().setCurFileSize(0);
//            this.setConditionTxt(TelegramKeys.EOF);
//
//        } catch ( Exception e){}
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(4);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}